"""
Copyright (c) 2009 [name + "(at)student.hpi.uni-potsdam.de" for name in ["murat.knecht", "franziska.haeger", "christian.schwarz"]]

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
"""
# Highly inspired by Timothy Downs, inputbox
import pygame, pygame.font, pygame.event, pygame.draw, string
from pygame.locals import *

from resourcemanager import ResourceManager

class ScoreBoard(object):
	@classmethod
	def get_key(cls):
		while True:
			event = pygame.event.poll()
			if event.type == KEYDOWN:
				return event.key
	
	@classmethod
	def display_box(cls, surface, message, name):
		"""Print a message in a box in the middle of the screen"""
		rect = surface.get_rect()
		
		fontobject = ResourceManager.get_font(20)
		pygame.draw.rect(surface, (128,128,128,200),
						 ((surface.get_width() / 2) - 102,
						 (surface.get_height() / 2) - 200,
						 204, 194), 0)
		
		pygame.draw.rect(surface, (0,0,0),
						 ((surface.get_width() / 2) - 102,
						 (surface.get_height() / 2) - 12,
						 204, 24), 0)
		
		pygame.draw.rect(surface, (255,255,255),
						 ((surface.get_width() / 2) - 102,
						 (surface.get_height() / 2) - 12,
						 204, 24), 1)
		
		padding = 20
		for msg in message:
			surface.blit(fontobject.render(msg, 1, (255,255,255)),
						 ((surface.get_width() / 2) - 100, (surface.get_height() / 2) - 220 + padding))
			
			padding += 20
		
		surface.blit(fontobject.render("Your Name: ", 1, (255,255,255)),
					((surface.get_width() / 2) - 100, (surface.get_height() / 2) - 180 + padding))
		
		if len(name) != 0:
			 surface.blit(fontobject.render(name, 1, (255,255,255)),
						  ((surface.get_width() / 2) - 100, (surface.get_height() / 2) - 10))
		
		pygame.display.flip()

	@classmethod
	def showScore(cls, surface, scoreMsgs):
		current_string = []
		cls.display_box(surface, scoreMsgs, "Your Name: " + string.join(current_string,""))
		
		c = ""
		while True:
			inkey = cls.get_key()
			if inkey == K_BACKSPACE:
				current_string = current_string[0:-1]
			elif inkey == K_RETURN:
				break
			elif inkey <= 127:
				c = unichr(inkey)
			
			if c:
				current_string.append(c)
				c = ""
			
			cls.display_box(surface, scoreMsgs, string.join(current_string,""))
		
		return string.join(current_string,"")


def run():
	"""Initializes the pygame sub system."""
	pygame.init()
	window = pygame.display.set_mode((800, 600), pygame.DOUBLEBUF | pygame.RESIZABLE)
	pygame.display.set_caption("@todo implement me!!!")
	
	screen = pygame.display.get_surface()
	screen.fill((255, 0, 0))
	print ScoreBoard.showScore(screen, ["This is a test"])

if __name__ == "__main__":
	run()
	#raw_input()
	#import cProfile
	#cProfile.run("run()", filename = "prof.cprof")
	
	#import pstats
	#stats = pstats.Stats("prof.cprof")
	#stats.strip_dirs().sort_stats("time").print_stats(30)